USACO Section 3.3 Camlot

BFS.先算出棋盘上每个点到各个点knight需要的步数;然后枚举所有点,其中再枚举king是自己到的还是knight带它去的(假如是knight带它的,枚举king周围的2格(网上都这么说,似乎是个结论?还是usaco数据太弱了?不过看跑出来的时间,全部枚举或许也可以))。一开始觉得挺麻烦的,不过只要思路清晰写起来应该也没多大问题。大概就是这样了.

#include<cstdio>
#include<iostream>
#include<algorithm>
#include<cstring>
#include<queue>
#include<cmath>

#define rep(i,l,r) for(int i=l;i<=r;i++)
#define dow(i,l,r) for(int i=l;i>=r;i--)
#define clr(x,c) memset(x,c,sizeof x)

using namespace std;

const int inf=0x3f3f3f3f,maxr=30+5,maxc=26+5;
const int dir[8][2]={{-2,1},{-1,2},{1,2},{2,1},{2,-1},{1,-2},{-1,-2},{-2,-1}};
int d[maxr][maxc][maxr][maxc];
int r,c,num=0;

struct coor { int x,y; };

queue<coor> q;
coor king,knight[maxr*maxc];

void init() {
    cin>>r>>c;
    char p;
    int t;
    cin>>p>>t;
    king={t,p-‘A‘+1};
    while(cin>>p>>t) knight[++num]={t,p-‘A‘+1};

    clr(d,inf);
    rep(i,1,r) rep(j,1,c) {
        d[i][j][i][j]=0;
        q.push((coor){i,j});
        while(!q.empty()) {
            coor e=q.front(); q.pop();
            rep(k,0,7) {
                int x=e.x+dir[k][0];
                int y=e.y+dir[k][1];
                if(x<=0 || x>r || y<=0 || y>c) continue;
                if(d[i][j][x][y]==inf) {
                    d[i][j][x][y]=d[i][j][e.x][e.y]+1;
                    q.push((coor){x,y});
                }
            }
        }
    }
}

int s() {
    int ans=inf;
    int i=5,j=2;
    rep(i,1,r) rep(j,1,c) {
        int w=0,t=inf;
        rep(k,1,num) {
            coor e=knight[k];
            w+=d[i][j][e.x][e.y];
        }

        rep(a,max(king.x-2,1),min(king.x+2,r))
            rep(b,max(king.y-2,1),min(king.y+2,c))
                rep(k,1,num) {
                    coor e=knight[k];
                    int x=abs(king.x-a);
                    int y=abs(king.y-b);
                    t=min(t,d[i][j][a][b]+d[a][b][e.x][e.y]+x+y-min(x,y)-d[i][j][e.x][e.y]);
                }

        int x=abs(king.x-i);
        int y=abs(king.y-j);
        int h=min(x+y-min(x,y),t)+w;
        ans= h>=0 && h<ans ? h:ans;
    }
    return ans;
}

int main() {
    freopen("camelot.in","r",stdin);
    freopen("camelot.out","w",stdout);

    init();
    cout<<s()<<endl;

    fclose(stdin);
    fclose(stdout);
    return 0;
}

时间: 2024-08-02 10:57:55

USACO Section 3.3 Camlot的相关文章

USACO Section 2.1 Healthy Holsteins

/* ID: lucien23 PROG: holstein LANG: C++ */ #include <iostream> #include <fstream> #include <vector> using namespace std; bool compFun(int x, int y) { int temp, i = 0; while (true) { temp = 1 << i; if (temp&x > temp&y) {

USACO Section 2.2 Party Lamps

/* ID: lucien23 PROG: lamps LANG: C++ */ /* * 此题的技巧之处就是需要注意到任何button只要按下2的倍数次就相当于没有按 * 所以其实只需要考虑4个按钮,每个按钮是否被有效按下过一次就好 * 直接使用枚举法,一共只有2^4=16种情况 * 对于每种情况需要知道被按下的有效次数(也就是被按下过的按钮数),必须满足 * (C-有效次数)%2=0才行,这样其他次数才能视为无效 * 然后验证各种情况是否符合要求,将符合要求的情况按序输出即可 */ #inc

USACO Section 2.2 Runaround Numbers

/* ID: lucien23 PROG: runround LANG: C++ */ #include <iostream> #include <fstream> #include <cstring> using namespace std; int main() { ifstream infile("runround.in"); ofstream outfile("runround.out"); if(!infile || !

USACO Section 2.2 Preface Numbering

/* ID: lucien23 PROG: preface LANG: C++ */ #include <iostream> #include <fstream> #include <string> #include <map> using namespace std; int main() { ifstream infile("preface.in"); ofstream outfile("preface.out")

USACO Section 2.1 Sorting a Three-Valued Sequence

/* ID: lucien23 PROG: sort3 LANG: C++ */ #include <iostream> #include <fstream> #include <vector> #include <algorithm> using namespace std; void exchange(int nums[], int begin, int end, int N, int x); int sum = 0; int main() { ifst

USACO Section 1.1 Your Ride Is Here

原题: Your Ride Is Here It is a well-known fact that behind every good comet is a UFO. These UFOs often come to collect loyal supporters from here on Earth. Unfortunately, they only have room to pick up one group of followers on each trip. They do, how

[IOI1996] USACO Section 5.3 Network of Schools(强连通分量)

nocow上的题解很好. http://www.nocow.cn/index.php/USACO/schlnet 如何求强连通分量呢?对于此题,可以直接先用floyd,然后再判断. ---------------------------------------------------------------------------------- #include<cstdio> #include<iostream> #include<algorithm> #includ

USACO Section 5.3 Big Barn(dp)

USACO前面好像有类似的题目..dp(i,j)=min(dp(i+1,j),dp(i+1,j+1),dp(i,j+1))+1  (坐标(i,j)处无tree;有tree自然dp(i,j)=0) .dp(i,j)表示以坐标(i,j)为左上角的barn边长最大值,dp(i+1,j),dp(i,j+1)分别表示向右和向下能扩展的最大边长,但是以此为正方形时,右下方的一个格子没有考虑到,所以就+个dp(i+1,j+1).边界为:dp(i,j)=1(i==n-1或j==n-1). -----------

USACO Section 1.1PROB Your Ride Is Here

题目传送门 不能提交哦   http://www.nocow.cn/index.php/Translate:USACO/ride /* ID: jusonal1 PROG: ride LANG: C++ */ #include <iostream> #include <fstream> #include <string> #include <cstdio> #include <algorithm> using namespace std; int